Clean up and exit on SIGINT.
[arvados-dev.git] / jenkins / run-tests.sh
index 98734ca62dd72f6d2a812bd88af204c5b849104f..b87a7f5b4e81f01c436e9530c6d912df1490d805 100755 (executable)
@@ -126,6 +126,16 @@ report_outcomes() {
     fi
 }
 
+exit_cleanly() {
+    trap - INT
+    rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
+    stop_api
+    rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
+    report_outcomes
+    clear_temp
+    exit ${#failures}
+}
+
 sanity_checks() {
   # Make sure WORKSPACE is set
   if ! [[ -n "$WORKSPACE" ]]; then
@@ -165,7 +175,6 @@ sanity_checks() {
     echo >&2
     exit 1
   fi
-
 }
 
 rotate_logfile() {
@@ -221,6 +230,29 @@ do
     esac
 done
 
+start_api() {
+    echo 'Starting API server...'
+    cd "$WORKSPACE" \
+        && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
+        && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
+        && export ARVADOS_TEST_API_INSTALLED="$$" \
+        && (env | egrep ^ARVADOS)
+}
+
+stop_api() {
+    if [[ -n "$ARVADOS_TEST_API_HOST" ]]; then
+        unset ARVADOS_TEST_API_HOST
+        cd "$WORKSPACE" \
+            && python sdk/python/tests/run_test_server.py stop
+    fi
+}
+
+interrupt() {
+    failures+=("($(basename $0) interrupted)")
+    exit_cleanly
+}
+trap interrupt INT
+
 sanity_checks
 
 echo "WORKSPACE=$WORKSPACE"
@@ -336,10 +368,6 @@ fi
 # Needed for run_test_server.py which is used by certain (non-Python) tests.
 pip install PyYAML || fatal "pip install PyYAML failed"
 
-# Needed for python-daemon 2.0.2, which breaks otherwise with
-# "ImportError: No module named docutils.core"
-pip install docutils || fatal "pip install docutils failed"
-
 checkexit() {
     if [[ "$?" != "0" ]]; then
         title "!!!!!! $1 FAILED !!!!!!"
@@ -413,11 +441,21 @@ title () {
     printf "\n%*s%s\n\n" $((($COLUMNS-${#txt})/2)) "" "$txt"
 }
 
+bundle_install_trylocal() {
+    (
+        set -e
+        echo "(Running bundle install --local. 'could not find package' messages are OK.)"
+        if ! bundle install --local --no-deployment; then
+            echo "(Running bundle install again, without --local.)"
+            bundle install --no-deployment
+        fi
+        bundle package --all
+    )
+}
+
 install_doc() {
     cd "$WORKSPACE/doc" \
-        && (bundle install --local --no-deployment \
-        || bundle install --no-deployment) \
-        && bundle package --all \
+        && bundle_install_trylocal \
         && rm -rf .site
 }
 do_install doc
@@ -425,9 +463,7 @@ do_install doc
 install_ruby_sdk() {
     with_test_gemset gem uninstall --force --all --executables arvados \
         && cd "$WORKSPACE/sdk/ruby" \
-        && (bundle install --local --no-deployment \
-        || bundle install --no-deployment) \
-        && bundle package --all \
+        && bundle_install_trylocal \
         && gem build arvados.gemspec \
         && with_test_gemset gem install --no-ri --no-rdoc `ls -t arvados-*.gem|head -n1`
 }
@@ -436,9 +472,7 @@ do_install sdk/ruby ruby_sdk
 install_cli() {
     with_test_gemset gem uninstall --force --all --executables arvados-cli \
         && cd "$WORKSPACE/sdk/cli" \
-        && (bundle install --local --no-deployment \
-        || bundle install --no-deployment) \
-        && bundle package --all \
+        && bundle_install_trylocal \
         && gem build arvados-cli.gemspec \
         && with_test_gemset gem install --no-ri --no-rdoc `ls -t arvados-cli-*.gem|head -n1`
 }
@@ -462,9 +496,7 @@ done
 
 install_apiserver() {
     cd "$WORKSPACE/services/api" \
-        && (RAILS_ENV=test bundle install --local --no-deployment \
-        || RAILS_ENV=test bundle install --no-deployment) \
-        && bundle package --all
+        && RAILS_ENV=test bundle_install_trylocal
 
     rm -f config/environments/test.rb
     cp config/environments/test.rb.example config/environments/test.rb
@@ -525,27 +557,11 @@ done
 
 install_workbench() {
     cd "$WORKSPACE/apps/workbench" \
-        && (RAILS_ENV=test bundle install --local --no-deployment \
-        || RAILS_ENV=test bundle install --no-deployment) \
-        && bundle package --all
+        && mkdir -p tmp/cache \
+        && RAILS_ENV=test bundle_install_trylocal
 }
 do_install apps/workbench workbench
 
-start_api() {
-    echo 'Starting API server...'
-    cd "$WORKSPACE" && \
-        eval $(python sdk/python/tests/run_test_server.py start --auth admin) && \
-        export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" && \
-        export ARVADOS_TEST_API_INSTALLED="$$" && \
-        (env | egrep ^ARVADOS)
-}
-
-stop_api() {
-    unset ARVADOS_TEST_API_HOST
-    cd "$WORKSPACE" && \
-        python sdk/python/tests/run_test_server.py stop
-}
-
 test_doclinkchecker() {
     (
         set -e
@@ -561,8 +577,8 @@ do_test doc doclinkchecker
 stop_api
 
 test_apiserver() {
-    cd "$WORKSPACE/services/api"
-    RAILS_ENV=test bundle exec rake test ${testargs[services/api]}
+    cd "$WORKSPACE/services/api" \
+        && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
 }
 do_test services/api apiserver
 
@@ -570,14 +586,14 @@ start_api
 
 test_ruby_sdk() {
     cd "$WORKSPACE/sdk/ruby" \
-        && bundle exec rake test ${testargs[sdk/ruby]}
+        && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
 }
 do_test sdk/ruby ruby_sdk
 
 test_cli() {
     cd "$WORKSPACE/sdk/cli" \
         && mkdir -p /tmp/keep \
-        && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test ${testargs[sdk/cli]}
+        && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
 }
 do_test sdk/cli cli
 
@@ -593,7 +609,7 @@ done
 
 test_workbench() {
     cd "$WORKSPACE/apps/workbench" \
-        && RAILS_ENV=test bundle exec rake test ${testargs[apps/workbench]}
+        && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[apps/workbench]}
 }
 do_test apps/workbench workbench
 
@@ -609,12 +625,4 @@ test_workbench_profile() {
 }
 do_test apps/workbench_profile workbench_profile
 
-rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
-
-stop_api
-rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
-
-report_outcomes
-clear_temp
-
-exit ${#failures}
+exit_cleanly